// CtrlMapDlg.cpp : implementation file
//

#include "stdafx.h"
#include "midifish.h"
#include "CtrlMapDlg.h"
#include "CtrlMap.h"
#include "Doc.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif



CtrlMapDlg::CtrlMapDlg(CtrlMap *map, Doc *doc)
	: CDialog(CtrlMapDlg::IDD, NULL)
{
	mMap = map;
	mDoc = doc;

	//{{AFX_DATA_INIT(CtrlMapDlg)
	//}}AFX_DATA_INIT
}



void CtrlMapDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CtrlMapDlg)
	DDX_Control(pDX, IDC_STATIC_OUT2, mStaticOut2);
	DDX_Control(pDX, IDC_STATIC_OUT1, mStaticOut1);
	DDX_Control(pDX, IDC_STATIC_IN2, mStaticIn2);
	DDX_Control(pDX, IDC_STATIC_IN1, mStaticIn1);
	DDX_Control(pDX, IDC_POS_TEXT_OUT2, mPosTextOut2);
	DDX_Control(pDX, IDC_POS_TEXT_OUT1, mPosTextOut1);
	DDX_Control(pDX, IDC_POS_BAR_OUT2, mPosBarOut2);
	DDX_Control(pDX, IDC_POS_BAR_OUT1, mPosBarOut1);
	DDX_Control(pDX, IDC_MIN_SLIDER_OUT2, mMinSliderOut2);
	DDX_Control(pDX, IDC_MIN_SLIDER_OUT1, mMinSliderOut1);
	DDX_Control(pDX, IDC_MIN_SLIDER_IN2, mMinSliderIn2);
	DDX_Control(pDX, IDC_MIN_SLIDER_IN1, mMinSliderIn1);
	DDX_Control(pDX, IDC_MIN_EDIT_OUT2, mMinEditOut2);
	DDX_Control(pDX, IDC_MIN_EDIT_OUT1, mMinEditOut1);
	DDX_Control(pDX, IDC_MIN_EDIT_IN2, mMinEditIn2);
	DDX_Control(pDX, IDC_MIN_EDIT_IN1, mMinEditIn1);
	DDX_Control(pDX, IDC_MAX_SLIDER_OUT2, mMaxSliderOut2);
	DDX_Control(pDX, IDC_MAX_SLIDER_OUT1, mMaxSliderOut1);
	DDX_Control(pDX, IDC_MAX_SLIDER_IN2, mMaxSliderIn2);
	DDX_Control(pDX, IDC_MAX_SLIDER_IN1, mMaxSliderIn1);
	DDX_Control(pDX, IDC_MAX_EDIT_OUT2, mMaxEditOut2);
	DDX_Control(pDX, IDC_MAX_EDIT_OUT1, mMaxEditOut1);
	DDX_Control(pDX, IDC_MAX_EDIT_IN2, mMaxEditIn2);
	DDX_Control(pDX, IDC_MAX_EDIT_IN1, mMaxEditIn1);
	DDX_Control(pDX, IDC_CTRL_OUT2, mCtrlOut2);
	DDX_Control(pDX, IDC_CTRL_OUT1, mCtrlOut1);
	DDX_Control(pDX, IDC_CTRL_IN, mCtrlIn);
	DDX_Control(pDX, IDC_POS_TEXT_IN, mPosTextIn);
	DDX_Control(pDX, IDC_POS_BAR_IN, mPosBarIn);
	//}}AFX_DATA_MAP

	if (!pDX->m_bSaveAndValidate) {
		// input controller listbox
		mCtrlIn.SetRedraw(false);
		mCtrlIn.ResetContent();
		mCtrlIn.AddString(CtrlMap::mNames[mMap->mType]);
		mCtrlIn.SetRedraw(true);

		for (int i=0; i<2; i++) {
			// output combo boxes
			CComboBox &combo = (i) ? mCtrlOut2 : mCtrlOut1;

			combo.SetRedraw(false);
			combo.ResetContent();

			combo.AddString("<none>");

			for (int j=0; j<CtrlMap::NUM_TYPES; j++)
				combo.AddString(CtrlMap::mNames[j]);

			combo.SetCurSel(mMap->mOut[i]+1);

			combo.SetRedraw(true);

			// input ranges
			int min, max;

			CtrlMap::get_range(mMap->mType, min, max);

			CSliderCtrl &min_slider_in = (i) ? mMinSliderIn2 : mMinSliderIn1;
			CSliderCtrl &max_slider_in = (i) ? mMaxSliderIn2 : mMaxSliderIn1;

			min_slider_in.SetRange(min, max, true);
			min_slider_in.SetPos(mMap->mInMin[i]);

			max_slider_in.SetRange(min, max, true);
			max_slider_in.SetPos(mMap->mInMax[i]);

			mPosBarIn.SetRange(min+8192, max+8192);

			// output ranges
			CtrlMap::get_range(mMap->mOut[i], min, max);

			CSliderCtrl &min_slider_out = (i) ? mMinSliderOut2 : mMinSliderOut1;
			CSliderCtrl &max_slider_out = (i) ? mMaxSliderOut2 : mMaxSliderOut1;

			min_slider_out.SetRange(min, max, true);
			min_slider_out.SetPos(mMap->mOutMin[i]);

			max_slider_out.SetRange(min, max, true);
			max_slider_out.SetPos(mMap->mOutMax[i]);

			CProgressCtrl &bar_out = (i) ? mPosBarOut2 : mPosBarOut1;
			CStatic &text_out = (i) ? mPosTextOut2 : mPosTextOut1;

			bar_out.SetRange(min+8192, max+8192);

			// edit fields
			CString s;

			CEdit &min_edit_in  = (i) ? mMinEditIn2  : mMinEditIn1;
			CEdit &max_edit_in  = (i) ? mMaxEditIn2  : mMaxEditIn1;
			CEdit &min_edit_out = (i) ? mMinEditOut2 : mMinEditOut1;
			CEdit &max_edit_out = (i) ? mMaxEditOut2 : mMaxEditOut1;

			s.Format("%d", mMap->mInMin[i]);
			min_edit_in.SetWindowText(s);

			s.Format("%d", mMap->mInMax[i]);
			max_edit_in.SetWindowText(s);

			s.Format("%d", mMap->mOutMin[i]);
			min_edit_out.SetWindowText(s);

			s.Format("%d", mMap->mOutMax[i]);
			max_edit_out.SetWindowText(s);

			// show/hide
			min_slider_in.ShowWindow(mMap->mOut[i] >= 0);
			max_slider_in.ShowWindow(mMap->mOut[i] >= 0);

			min_slider_out.ShowWindow(mMap->mOut[i] >= 0);
			max_slider_out.ShowWindow(mMap->mOut[i] >= 0);

			min_edit_in.ShowWindow(mMap->mOut[i] >= 0);
			max_edit_in.ShowWindow(mMap->mOut[i] >= 0);

			min_edit_out.ShowWindow(mMap->mOut[i] >= 0);
			max_edit_out.ShowWindow(mMap->mOut[i] >= 0);

			bar_out.ShowWindow(mMap->mOut[i] >= 0);
			text_out.ShowWindow(mMap->mOut[i] >= 0);

			CStatic &static_in = (i) ? mStaticIn2 : mStaticIn1;
			CStatic &static_out = (i) ? mStaticOut2 : mStaticOut1;

			static_in.ShowWindow(mMap->mOut[i] >= 0);
			static_out.ShowWindow(mMap->mOut[i] >= 0);
		}
	}
}



BEGIN_MESSAGE_MAP(CtrlMapDlg, CDialog)
	//{{AFX_MSG_MAP(CtrlMapDlg)
	ON_WM_DESTROY()
	ON_WM_HSCROLL()
	ON_WM_TIMER()
	ON_CBN_SELCHANGE(IDC_CTRL_OUT1, OnSelchangeCtrlOut1)
	ON_CBN_SELCHANGE(IDC_CTRL_OUT2, OnSelchangeCtrlOut2)
	ON_EN_CHANGE(IDC_MAX_EDIT_IN1, OnChangeMaxEditIn1)
	ON_EN_CHANGE(IDC_MAX_EDIT_IN2, OnChangeMaxEditIn2)
	ON_EN_CHANGE(IDC_MAX_EDIT_OUT1, OnChangeMaxEditOut1)
	ON_EN_CHANGE(IDC_MAX_EDIT_OUT2, OnChangeMaxEditOut2)
	ON_EN_CHANGE(IDC_MIN_EDIT_IN1, OnChangeMinEditIn1)
	ON_EN_CHANGE(IDC_MIN_EDIT_IN2, OnChangeMinEditIn2)
	ON_EN_CHANGE(IDC_MIN_EDIT_OUT1, OnChangeMinEditOut1)
	ON_EN_CHANGE(IDC_MIN_EDIT_OUT2, OnChangeMinEditOut2)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()



BOOL CtrlMapDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	mTimer = SetTimer(2, 50, NULL);

	return TRUE;
}



void CtrlMapDlg::OnDestroy() 
{
	KillTimer(mTimer);

	CDialog::OnDestroy();
}



void CtrlMapDlg::OnSelchangeCtrlOut1() 
{
	mMap->mOut[0] = mCtrlOut1.GetCurSel() - 1;

	mMap->get_range(mMap->mOut[0], mMap->mOutMin[0], mMap->mOutMax[0]);

	UpdateData(false);
}



void CtrlMapDlg::OnSelchangeCtrlOut2() 
{
	mMap->mOut[1] = mCtrlOut2.GetCurSel() - 1;

	mMap->get_range(mMap->mOut[1], mMap->mOutMin[1], mMap->mOutMax[1]);

	UpdateData(false);
}



static void slide(int &val, CSliderCtrl &slider, CEdit &edit)
{
	val = slider.GetPos();

	CString s;
	s.Format("%d", val);

	edit.SetWindowText(s);
}



void CtrlMapDlg::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar *pScrollBar) 
{
	CSliderCtrl *slider = (CSliderCtrl *)pScrollBar;

	if (slider == &mMinSliderIn1)
		slide(mMap->mInMin[0], mMinSliderIn1, mMinEditIn1);
	else if (slider == &mMaxSliderIn1)
		slide(mMap->mInMax[0], mMaxSliderIn1, mMaxEditIn1);
	else if (slider == &mMinSliderOut1)
		slide(mMap->mOutMin[0], mMinSliderOut1, mMinEditOut1);
	else if (slider == &mMaxSliderOut1)
		slide(mMap->mOutMax[0], mMaxSliderOut1, mMaxEditOut1);
	else if (slider == &mMinSliderIn2)
		slide(mMap->mInMin[1], mMinSliderIn2, mMinEditIn2);
	else if (slider == &mMaxSliderIn2)
		slide(mMap->mInMax[1], mMaxSliderIn2, mMaxEditIn2);
	else if (slider == &mMinSliderOut2)
		slide(mMap->mOutMin[1], mMinSliderOut2, mMinEditOut2);
	else if (slider == &mMaxSliderOut2)
		slide(mMap->mOutMax[1], mMaxSliderOut2, mMaxEditOut2);
}



void CtrlMapDlg::OnTimer(UINT nIDEvent) 
{
	CString s;

	s.Format("%d", mDoc->mCtrlIn[mMap->mType]);

	mPosTextIn.SetWindowText(s);

	mPosBarIn.SetPos(mDoc->mCtrlIn[mMap->mType]+8192);

	if (mMap->mOut[0] >= 0) {
		s.Format("%d", mDoc->mCtrlOut[mMap->mOut[0]]);

		mPosTextOut1.SetWindowText(s);

		mPosBarOut1.SetPos(mDoc->mCtrlOut[mMap->mOut[0]]+8192);
	}

	if (mMap->mOut[1] >= 0) {
		s.Format("%d", mDoc->mCtrlOut[mMap->mOut[1]]);

		mPosTextOut2.SetWindowText(s);

		mPosBarOut2.SetPos(mDoc->mCtrlOut[mMap->mOut[1]]+8192);
	}
}



void CtrlMapDlg::OnChangeMaxEditIn1() 
{
	CString s;

	mMaxEditIn1.GetWindowText(s);

	int n = atoi(s);

	int min, max;

	mMap->get_range(mMap->mType, min, max);

	if (n < min)
		n = min;
	else if (n > max)
		n = max;

	mMap->mInMax[0] = n;

	mMaxSliderIn1.SetPos(n);
}



void CtrlMapDlg::OnChangeMaxEditIn2() 
{
	CString s;

	mMaxEditIn2.GetWindowText(s);

	int n = atoi(s);

	int min, max;

	mMap->get_range(mMap->mType, min, max);

	if (n < min)
		n = min;
	else if (n > max)
		n = max;

	mMap->mInMax[1] = n;

	mMaxSliderIn2.SetPos(n);
}



void CtrlMapDlg::OnChangeMaxEditOut1() 
{
	CString s;

	mMaxEditOut1.GetWindowText(s);

	int n = atoi(s);

	int min, max;

	mMap->get_range(mMap->mOut[0], min, max);

	if (n < min)
		n = min;
	else if (n > max)
		n = max;

	mMap->mOutMax[0] = n;

	mMaxSliderOut1.SetPos(n);
}



void CtrlMapDlg::OnChangeMaxEditOut2() 
{
	CString s;

	mMaxEditOut2.GetWindowText(s);

	int n = atoi(s);

	int min, max;

	mMap->get_range(mMap->mOut[1], min, max);

	if (n < min)
		n = min;
	else if (n > max)
		n = max;

	mMap->mOutMax[1] = n;

	mMaxSliderOut2.SetPos(n);
}



void CtrlMapDlg::OnChangeMinEditIn1() 
{
	CString s;

	mMinEditIn1.GetWindowText(s);

	int n = atoi(s);

	int min, max;

	mMap->get_range(mMap->mType, min, max);

	if (n < min)
		n = min;
	else if (n > max)
		n = max;

	mMap->mInMin[0] = n;

	mMinSliderIn1.SetPos(n);
}



void CtrlMapDlg::OnChangeMinEditIn2() 
{
	CString s;

	mMinEditIn2.GetWindowText(s);

	int n = atoi(s);

	int min, max;

	mMap->get_range(mMap->mType, min, max);

	if (n < min)
		n = min;
	else if (n > max)
		n = max;

	mMap->mInMin[1] = n;

	mMinSliderIn2.SetPos(n);
}



void CtrlMapDlg::OnChangeMinEditOut1() 
{
	CString s;
	
	mMinEditOut1.GetWindowText(s);
	
	int n = atoi(s);

	int min, max;

	mMap->get_range(mMap->mOut[0], min, max);

	if (n < min)
		n = min;
	else if (n > max)
		n = max;

	mMap->mOutMin[0] = n;

	mMinSliderOut1.SetPos(n);
}



void CtrlMapDlg::OnChangeMinEditOut2() 
{
	CString s;
	
	mMinEditOut2.GetWindowText(s);
	
	int n = atoi(s);

	int min, max;

	mMap->get_range(mMap->mOut[1], min, max);

	if (n < min)
		n = min;
	else if (n > max)
		n = max;

	mMap->mOutMin[1] = n;

	mMinSliderOut2.SetPos(n);
}

