#if !defined(AFX_KEYMAPDLG_H__E0B2AD27_0F14_461C_9E48_DD4D10114936__INCLUDED_)
#define AFX_KEYMAPDLG_H__E0B2AD27_0F14_461C_9E48_DD4D10114936__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// KeyMapDlg.h : header file
//

#include "keymap.h"



class ZoneButton : public CButton
{
public:
	ZoneButton(KeyMap *map, class KeyMapDlg *dlg);
	~ZoneButton();

	KeyMap *mMap;

	class KeyMapDlg *mDlg;

	virtual void DrawItem(LPDRAWITEMSTRUCT lpDrawItemStruct);

	int mCtrl[2];

	CDC *mDC;
	CBitmap *mBitmap;
	CBitmap *mPrevBitmap;
};



class KeyMapDlg : public CDialog
{
// Construction
public:
	KeyMapDlg(KeyMap *map, class Doc *doc);

	KeyMap *mMap;
	KeyMap::Entry *mEntry;

	int mEntryX;
	int mEntryY;

	int mDragX;
	int mDragY;

	int mDragCol;
	int mDragRow;

	POINT mDragStart;

	int mDragColOrig;
	int mDragRowOrig;

	bool mDragging;

	class Doc *mDoc;

	int mTimer;

	bool point_to_zone(POINT point, int &x, int &y);

	bool hit_test(int pos_x, int pos_y, int &cell_x, int &cell_y);

// Dialog Data
	//{{AFX_DATA(KeyMapDlg)
	enum { IDD = IDD_KEY_MAP };
	ZoneButton mZones;
	CStatic	mVelOffsetLabel;
	CStatic	mVelScaleLabel;
	CSliderCtrl	mVCrossfade;
	CComboBox	mVController;
	CSliderCtrl	mVelScaleSlider;
	CEdit	mVelScaleEdit;
	CSliderCtrl	mVelOffsetSlider;
	CEdit	mVelOffsetEdit;
	CComboBox	mPortOut;
	CComboBox	mKeyOut;
	CListBox	mKeyIn;
	CSliderCtrl	mHCrossfade;
	CComboBox	mHController;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(KeyMapDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(KeyMapDlg)
	afx_msg void OnHsplitAdd();
	afx_msg void OnVsplitAdd();
	afx_msg void OnSelchangeHsplitController();
	afx_msg void OnSelchangeVsplitController();
	afx_msg void OnSelchangeKeyOut();
	afx_msg void OnSelchangePortOut();
	afx_msg void OnChangeVelOffsetEdit();
	afx_msg void OnChangeVelScaleEdit();
	afx_msg void OnDestroy();
	afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	virtual BOOL OnInitDialog();
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnHsplitRemove();
	afx_msg void OnVsplitRemove();
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnCaptureChanged(CWnd *pWnd);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_KEYMAPDLG_H__E0B2AD27_0F14_461C_9E48_DD4D10114936__INCLUDED_)
