// Controller mapping class

#ifndef __CTRLMAP_H__
#define __CTRLMAP_H__



class CtrlMap
{
public:
	// list of controller types
	static const char *mNames[];

	enum TYPE
	{
		NONE = -1,
		KEY,
		VELOCITY,
		KEY_PRESSURE,
		AFTERTOUCH,
		PITCH_BEND,
		CONTROLLER,
		NUM_TYPES = CONTROLLER+128
	};

	static void get_range(int type, int &min, int &max);


	// setup functions
	CtrlMap(int type);

	string get_desc();


	// file IO
	void load(FILE *file);
	void save(FILE *file);


	// data
	int mType;

	enum { NUM_MAPS = 2 };

	int mOut[NUM_MAPS];

	int mInMin[NUM_MAPS];
	int mInMax[NUM_MAPS];

	int mOutMin[NUM_MAPS];
	int mOutMax[NUM_MAPS];
};




#endif		// __CTRLMAP_H__
